package msdk

import (
	"fmt"
	"golib.gaore.com/GaoreGo/haiwai-common-sdk-go/sdk"
	"golib.gaore.com/GaoreGo/haiwai-common-sdk-go/sdk/requests"
)

const (
	VERSION = "2023-03-16"
	KEY     = "gaore!@#msdk"
)

var Host = requests.Host{
	Default: "msdk.api.gaore.com.hk",
	Func: func(s string, area string) string {
		if area != "" {
			fmt.Println("msdk.api.gaore.com." + area)
			return "msdk.api.gaore.com." + area
		}
		return "msdk.api.gaore.com.hk"
	},
}

type Client struct {
	sdk.Client
	ident string
}

func (c *Client) UpdateAdjustId(req *UpdateAdjustIdRequest) (resp *UpdateAdjustIdResponse, err error) {
	resp = CreateUpdateAdjustIdResponse()
	err = c.DoAction(req, resp)
	return
}

func NewClient(area string, env ...string) (client *Client, err error) {
	client = new(Client)
	err = client.InitWithArea(area, env...)
	return
}
