package www

import (
	"golib.gaore.com/GaoreGo/haiwai-common-sdk-go/sdk"
	"golib.gaore.com/GaoreGo/haiwai-common-sdk-go/sdk/requests"
)

const (
	VERSION = "2023-03-16"
	KEY     = "gaore!@#apisdk"
)

var HOST requests.Host = requests.Host{
	Default: "apisdk.gaore.com.hk",
	Func: func(s string, area string) string {
		defHost := "apisdk.gaore.com"
		if area != "" {
			return defHost + "." + area
		}
		return ""
	},
}

type Client struct {
	sdk.Client
}

func NewClientWithAccessKey(accesskey, secrect, source string) (client *Client, err error) {
	client = &Client{}
	err = client.InitWithAccessKey(accesskey, secrect, source)
	return
}

func NewClientWithAliAppcode(accesskey, secrect string, env ...string) (client *Client, err error) {
	client = &Client{}
	err = client.InitWithAliAppcode(accesskey, secrect, env...)
	return
}

func (c *Client) GetUserInfo(req *GetPwdRequest) (response *GetPwdResponse, err error) {
	response = CreateGetPwdResponse()
	err = c.DoAction(req, response)
	return
}

func (c *Client) UpdateAdjustId(req *UpdateAdjustIdRequest) (resp *UpdateAdjustIdResponse, err error) {
	resp = CreateUpdateAdjustIdResponse()
	err = c.DoAction(req, resp)
	return
}

func NewClient(area string, env ...string) (client *Client, err error) {
	client = new(Client)
	err = client.InitWithArea(area, env...)
	return
}
