package www

import (
	"fmt"
	"log"
	"testing"
)

func TestClient_GetUserInfo(t *testing.T) {

	c, err := NewClientWithAliAppcode("203874304", "9e5489a82dd641729186cdad166d81a3")
	if err != nil {
		t.Error(err)
	}

	req := CreateGetPwdRequest()
	req.UserName = "ttom666"

	resp, err := c.GetUserInfo(req)
	if err != nil {
		log.Fatalln(err)
	}
	fmt.Println(resp.GetHttpContentString())
	fmt.Println(resp.GetHttpHeaders())
}

func TestClient_UpdateAdjustId(t *testing.T) {
	req := CreateUpdateAdjustIdRequest()
	req.AdjustId = "8834ca659b22316354e9e9d6dd6b1904"
	req.Username = "xn94941370"
	req.GameId = 10002
	req.RegTime = 1678949413
	req.MakeSign()
	c, err := NewClient("hk", "")
	if err != nil {
		t.Error(err)
		return
	}
	resp, err := c.UpdateAdjustId(req)
	if err != nil {
		t.Error(err)
		return
	}
	t.Log(resp)
}
